#! /bin/bash

set -e

notify-send -u critical -i "/opt/vlibras_desktop/vlibras_player_Data/Resources/UnityPlayer.png" VLibras "Aguarde enquanto as dependências do VLibras são instaladas...
Isso pode levar alguns minutos!"

function update_dict_reset()
{
    DICT_RESET_FILE="/opt/vlibras_desktop/config/dict.reset"
    
    if [ -f $DICT_RESET_FILE ] ; then
        
        if [ -d "/opt/vlibras_desktop/vlibras_player_Data/Bundles" ]; then

            COUNT_FILES="$(ls /opt/vlibras_desktop/vlibras_player_Data/Bundles/*.description | wc -l)"
            
            if [ "$(($COUNT_FILES))" -gt "0" ]; then
                
                apt-get remove --purge --force-yes --yes dicionario-vlibras > /dev/null 2>&1
                
                for i in $(seq 1 $COUNT_FILES); do
                    # remove each patch by the number version
                    apt-get remove --purge --force-yes --yes patch${i}.0.0 > /dev/null 2>&1
                done
                
                # update list packages remove all dependencies
                apt-get autoremove --force-yes --yes > /dev/null 2>&1
                apt-get autoclean --force-yes --yes > /dev/null 2>&1

            fi   
        fi

        rm $DICT_RESET_FILE

    fi

}

case $2 in
  '')
    eval "$(debconf-apt-progress --config)"
    "$0" $1 debconf 
    ;;
  debconf)
    . /usr/share/debconf/confmodule
    case $1 in
        "vlibras-aelius")
            debconf-apt-progress --start
            debconf-apt-progress --from 0 --to 30 -- apt-get update
            debconf-apt-progress --from 30 --to 100 -- apt-get install --force-yes --yes vlibras-aelius
            debconf-apt-progress --stop
            ;;
        "dicionario-vlibras")
            debconf-apt-progress --start
            debconf-apt-progress --from 0 --to 25 -- apt-get update
            update_dict_reset
            debconf-apt-progress --from 25 --to 50 -- apt-get update
            debconf-apt-progress --from 50 --to 100 -- apt-get install --force-yes --yes dicionario-vlibras:i386
            debconf-apt-progress --stop
            ;;
        *) echo invalid option;;
    esac
esac

notify-send -u critical -i "/opt/vlibras_desktop/vlibras_player_Data/Resources/UnityPlayer.png"
VLibras-Desktop "As dependências foram instaladas e o VLibras está pronto para ser usado!"
